﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr185_1
{
    // Объявление делегата:
    delegate void MyDelegate(string txt);
    // Класс с событием: 
    class MyClass {
        // Закрытое поле (ссылка на экземпляр делегата)
        // для реализации списка обработчиков события:
        private MyDelegate myevent;
        // Объявление события (с описанием аксессоров): 
        public event MyDelegate MyEvent {
            // Аксессор для добавления метода в список
            // обработчиков события:
            add {
                // Добавление ссылки на метод в список вызовов
                // экземпляра делегата:
                myevent += value;
            }
            // Аксессор для удаления метода из списка
            // обработчиков события:
            remove {
                // Удаление ссылки на метод из списка вызовов
                // экземпляра делегата:
                myevent -= value;
            }
        }
        // Метод для генерирования события: 
        public void RaiseMyEvent(string txt) {
            // Если для события предусмотрены обработчики: 
            if (myevent != null) {
                // Генерирование события 
                // (вызов экземпляра делегата): 
                myevent(txt);
            }
        }
    }

    // Класс: 
    class Alpha {
        public string name; 
        public Alpha(string txt) {
            name = txt;
            } 
        public void show(string msg) {
            Console.WriteLine("Объект " + name + ":"); 
            Console.WriteLine(msg);
        }
    }

    // Класс с главным методом: 
    class Program
    {
        static void Main()
        {
            MyClass obj = new MyClass();
            Alpha A = new Alpha("A");
            Alpha B = new Alpha("B");
            obj.RaiseMyEvent("1-e событие");
            obj.MyEvent += A.show;
            obj.RaiseMyEvent("2-e событие");
            Console.WriteLine();
            obj.MyEvent += B.show;
            obj.RaiseMyEvent("3-e событие");
            Console.WriteLine();
            obj.MyEvent -= A.show;
            obj.RaiseMyEvent("4-e событие");
            Console.WriteLine();
            obj.MyEvent -= A.show;
            obj.MyEvent -= B.show;
            obj.RaiseMyEvent("5-e событие");
            MyDelegate md = A.show;
            md += B.show;
            obj.MyEvent += md;
            obj.RaiseMyEvent("6-e событие");
            // Задержка:
            Console.ReadLine();
        }
    }
}
